App.controller('Controller', function ($scope, $location) {
    var _this = this;
    _this.CurrentVersion = '1.2';

    _this.Auditoriums = [];
    for (var i = 0; i < 12; i++) {
        _this.Auditoriums.push({ AuditoriumNumber: i + 1 });
    }

    _this.Projectors = ['Barco DP4K-BLP', 'Christie CP4230', 'SONY R320'];
    _this.SoundProcessors = ['Barco APX AuroMax', 'Dolby CP650', 'Dolby CP750', 'Dolby CP850', 'Dolby CP950', 'QSC DCP 100', 'QSC DCP 300'];



    // onLoggedIn callback.  this is where we will read the config file
    jnrWebsocket.addOnLoggedInListener(function onLoggedIn() {
        console.log('onLoggedIn');

        // here we get the peers.  we will use the peers to connect to the other 
        // auditoriums.  it is likely that all or most of the jniors in a ibooth
        // complex are meant for this application.
        jnrWebsocket.getRegistryListing('peers', function (node, keys) {
            jnrWebsocket.readRegistryKeys(keys, function (keyName, value) {
                if (null != value) {
                    var ipAddress = value.split(' ')[0];
                    var series3 = -1 != keyName.indexOf('$2')
                        || -1 != keyName.indexOf('$3')
                        || -1 != keyName.indexOf('$4');
                    // ignore blank ip addresses or series 3 jniors
                    if ('0.0.0.0' != ipAddress && !series3) {
                        createPeerConnection(ipAddress);
                    }
                }
            });
        });

        peerConnections.push(new PeerConnection(jnrWebsocket, _this.Auditoriums));
    });



    var peerConnections = [];
    function createPeerConnection(ipAddress) {
        var newJnrWebsocket = new JnrWebsocket();
        newJnrWebsocket.connect('ws://' + ipAddress);
        newJnrWebsocket.addOnLoggedInListener(function onLoggedIn() {
            console.log('onLoggedIn');

            peerConnections.push(new PeerConnection(newJnrWebsocket, _this.Auditoriums));
        });
    }



    function PeerConnection(jnrWebsocket, auditoriums) {
        var _this = this;
        _this.jnrWebsocket = jnrWebsocket;
        _this.Auditoriums = auditoriums;
        _this.AuditoriumObject = { PeerConnection: this };


        _this.ProjectorChange = function () {
            _this.jnrWebsocket.registryWrite('appdata/ibooth/projectortype', _this.AuditoriumObject.ProjectorType);
            // alert(_this.AuditoriumObject.ProjectorType);
        };


        _this.SoundProcessorChange = function () {
            _this.jnrWebsocket.registryWrite('appdata/ibooth/soundprocessortype', _this.AuditoriumObject.SoundProcessorType);
            // alert(_this.AuditoriumObject.SoundProcessorType);
        };


        _this.jnrWebsocket.readRegistryKey('ipconfig/hostname', function (keyName, value) {
            if (null != value) {
                _this.AuditoriumObject.HostName = value;
                $scope.$apply();
            }
        });


        _this.jnrWebsocket.readRegistryKey('appdata/ibooth/auditoriumnumber', function (keyName, value) {
            if (null != value) {
                var auditoriumNumber = parseInt(value);
                _this.AuditoriumObject.AuditoriumNumber = auditoriumNumber;
                _this.Auditoriums[auditoriumNumber - 1] = _this.AuditoriumObject;
                $scope.$apply();
            }
        });


        _this.jnrWebsocket.readRegistryKey('appdata/ibooth/projectortype', function (keyName, value) {
            if (null != value) {
                _this.AuditoriumObject.ProjectorType = value;
                $scope.$apply();
            }
        });


        _this.jnrWebsocket.readRegistryKey('appdata/ibooth/projectoripaddress', function (keyName, value) {
            if (null != value) {
                _this.AuditoriumObject.ProjectorIpAddress = value;
                $scope.$apply();
            }
        });


        _this.jnrWebsocket.readRegistryKey('appdata/ibooth/soundprocessortype', function (keyName, value) {
            if (null != value) {
                _this.AuditoriumObject.SoundProcessorType = value;
                $scope.$apply();
            }
        });


        _this.jnrWebsocket.readRegistryKey('appdata/ibooth/soundprocessoripaddress', function (keyName, value) {
            if (null != value) {
                _this.AuditoriumObject.SoundProcessorIpAddress = value;
                $scope.$apply();
            }
        });


        jnrWebsocket.addOnMessageListener(function (jsonReply) {
            // var message = jsonReply.Message;
            // if ("status.update" === message) {
            //     _this.Auditoriums[_this.auditoriumObject.AuditoriumNumber - 1].Data = jsonReply.Data;
            //     $scope.$apply();
            // }
        });

    };
});